﻿using UnityEngine;
using UnityEngine.SceneManagement;
using System.Collections;

public class castMagic : MonoBehaviour {
    //Manipulate Animation
    Animator anim;

    /* Set the magics */

    //Ostium Apertum
    bool learnedDoor;

    bool learnedUntouch;

    GameObject objCollider = null;

    // Use this for initialization
    void Start () {
        //Get the animator
        anim = GetComponent<Animator>();
    }
	
	// Update is called once per frame
	void Update () {
        //Get the variable from the player setting
        learnedDoor = GameObject.Find("playerSetting").GetComponent<playerSettings>().learnedDoor; //Ostium Apertum
        learnedUntouch = GameObject.Find("playerSetting").GetComponent<playerSettings>().learnedUntouch; //Ostium Apertum


        //Ostium Apertum Keys
        if (Input.GetButtonDown("A")) {
            //Debug.Log(GameObject.Find("playerSetting").GetComponent<playerSettings>().healthPontsP1);
            //Check if the magic is already learned
            if (learnedDoor) {
                //Pay the price to cast the magic with blood
                GameObject.Find("PlayerRita").GetComponent<playerMoviment>().playerSpeed = 0;
                GameObject.Find("playerSetting").GetComponent<playerSettings>().healthPontsP1 -= 0.1f;
                Debug.Log(GameObject.Find("playerSetting").GetComponent<playerSettings>().healthPontsP1);
                //Start the player animation
                StartCoroutine(castDoorAnimation());
                //Check if the collider exist and is not null 
            }
        }

        if (Input.GetButtonDown("B")) {
            //Check if the magic is already learned
            if (learnedUntouch) {
                Debug.Log("untouch");
                //Pay the price to cast the magic with blood
                GameObject.Find("playerSetting").GetComponent<playerSettings>().healthPontsP1 -= 0.1f;
                Debug.Log(GameObject.Find("playerSetting").GetComponent<playerSettings>().healthPontsP1);
                //Start the player animation
                StartCoroutine(castUntouchAnimation());
                //Check if the collider exist and is not null 
            }
        }



        if (GameObject.Find("playerSetting").GetComponent<playerSettings>().healthPontsP1 < 0) {
            //GameObject.Find("playerSetting").GetComponent<playerSettings>().healthPontsP1 = 1;
            SceneManager.LoadScene("dead");
        }
    }

    IEnumerator castDoorAnimation() {
        anim.SetBool("door", true);
        
        yield return new WaitForSeconds(0.5f);
        GameObject.Find("PlayerRita").GetComponent<playerMoviment>().playerSpeed = 0.1f;
        anim.SetBool("door", false);
        if (objCollider) { 
            //Check if the object is the door
            if(objCollider.tag == "Door"){
                Debug.Log("Door Opened");
                //Active the animation to open the door
                objCollider.GetComponent<Animator>().SetBool("open", true);
            }
        }
    }

    IEnumerator castUntouchAnimation() {
        GameObject.Find("WallBarrier").GetComponent<BoxCollider2D>().enabled = false;
        yield return new WaitForSeconds(1f);
        GameObject.Find("WallBarrier").GetComponent<BoxCollider2D>().enabled = true;
    }

    //Magic Area
    void OnTriggerEnter2D(Collider2D collider) {
        Debug.Log(collider);
        objCollider = GameObject.Find(collider.name);
    }

    //Set the player away
    void OnTriggerExit() {
        objCollider = null;
    }
}
