﻿using UnityEngine;
using UnityEngine.SceneManagement;
using System.Collections;

public class doorControl : MonoBehaviour {
	
    void OnTriggerStay2D(Collider2D collider) {
        //Check get the distance between the player and the door
        float playerDoorDistance = Vector2.Distance(transform.position, GameObject.Find(collider.name).transform.position);
        //Debug.Log(playerDoorDistance);
        if (playerDoorDistance < 1.0f) {
            if (GetComponent<Animator>().GetBool("open")) {
                SceneManager.LoadScene("level2");
            }
        }
    }
}
